## r-base 4.1.2

=== DESCRIPTION ===
Package: Matrix
Version: 1.3-4
Date: 2021-05-24
Priority: recommended
Title: Sparse and Dense Matrix Classes and Methods
Contact: Doug and Martin <Matrix-authors@R-project.org>
Maintainer: Martin Maechler <mmaechler+Matrix@gmail.com>
Authors@R: c(person("Douglas","Bates", role="aut")
 , person("Martin","Maechler", role = c("aut","cre"), email="mmaechler+Matrix@gmail.com",
          comment = c(ORCID = "0000-0002-8685-9910"))
 , person("Timothy A.", "Davis", role="ctb",
           comment = c("SuiteSparse and 'cs' C libraries, notably CHOLMOD, AMD;
		       collaborators listed in
			dir(pattern = '^[A-Z]+[.]txt$', full.names=TRUE,
			    system.file('doc', 'SuiteSparse', package='Matrix'))"))
 , person("Jens", "Oehlschlägel", role="ctb", comment="initial nearPD()")
 , person("Jason", "Riedy", role="ctb",
          comment = c("condest() and onenormest() for octave",
 	  	      "Copyright: Regents of the University of California"))
 , person("R Core Team", role = "ctb", comment="base R matrix implementation")
 )
Description: A rich hierarchy of matrix classes, including triangular,
   symmetric, and diagonal matrices, both dense and sparse and with
   pattern, logical and numeric entries.   Numerous methods for and
   operations on these matrices, using 'LAPACK' and 'SuiteSparse' libraries.
Depends: R (>= 3.5.0)
Imports: methods, graphics, grid, stats, utils, lattice
Suggests: expm, MASS
Enhances: MatrixModels, graph, SparseM, sfsmisc, igraph, maptools, sp,
        spdep
EnhancesNote: line 2: for "Rd xrefs"
Encoding: UTF-8
LazyData: no
LazyDataNote: not possible, since we use data/*.R *and* our classes
BuildResaveData: no
License: GPL (>= 2) | file LICENCE
URL: http://Matrix.R-forge.R-project.org/
BugReports: https://r-forge.r-project.org/tracker/?group_id=61
NeedsCompilation: yes
Packaged: 2021-05-29 14:45:57 UTC; maechler
Author: Douglas Bates [aut],
  Martin Maechler [aut, cre] (<https://orcid.org/0000-0002-8685-9910>),
  Timothy A. Davis [ctb] (SuiteSparse and 'cs' C libraries, notably
    CHOLMOD, AMD; collaborators listed in dir(pattern =
    '^[A-Z]+[.]txt$', full.names=TRUE, system.file('doc',
    'SuiteSparse', package='Matrix'))),
  Jens Oehlschlägel [ctb] (initial nearPD()),
  Jason Riedy [ctb] (condest() and onenormest() for octave, Copyright:
    Regents of the University of California),
  R Core Team [ctb] (base R matrix implementation)
Repository: CRAN
Date/Publication: 2021-06-01 06:10:06 UTC

=== src/gnuwin32/Makefile ===
R_HOME = ../..

## first time through MkRules will not exist.

ifeq ($(wildcard MkRules?local),MkRules.local)
include MkRules.local
endif

include MkRules.rules
include ../../share/make/vars.mk

MK = $(MAKE) --no-print-directory

all:
	@$(MK) MkRules
	@if test -f  ../../SVN-REVISION ; then \
	  cp ../../SVN-REVISION ../../SVN-REVISION.bak ; \
	fi
	@$(MK) rbuild
	@$(MK) -C ../library -f Makefile.win all WIN=$(WIN)
	@$(MK) -C ../library -f Makefile.win docs
	@$(MK) NEWSdocs htmldocs docfiles
	@$(MK)  -C ../../po -f Makefile.win

bytecode: bytecode-base bytecode-recommended

bytecode-base:
	@$(MK) MkRules
	@if test -f  ../../SVN-REVISION ; then \
	  cp ../../SVN-REVISION ../../SVN-REVISION.bak ; \
	fi
	@$(MK) rbuild
	@$(MK) -C ../library -f Makefile.win bytecode WIN=$(WIN)
	@$(MK) -C ../library -f Makefile.win docs
	@$(MK) NEWSdocs htmldocs docfiles
	@$(MK)  -C ../../po -f Makefile.win


rpackages:
	@$(MK) -C ../library -f Makefile.win all WIN=$(WIN) EXT_LIBS="$(EXT_LIBS)"
	@$(MK) -C ../library -f Makefile.win docs

rpackages-cross:
	@$(MK) -C ../library -f Makefile.win cross WIN=$(WIN) EXT_LIBS="$(EXT_LIBS)"


cairodevices:
ifneq "$(USE_CAIRO)" ""
	@$(MK) -C ../library/grDevices/src/cairo -f Makefile.win all \
	  WIN=$(WIN) CAIRO_LIBS=$(CAIRO_LIBS) CAIRO_CPPFLAGS=$(CAIRO_CPPFLAGS)
endif

ifeq ($(wildcard MkRules?local),MkRules.local)
MkRules: MkRules.local MkRules.rules
	@cat MkRules.local MkRules.rules > MkRules
else
MkRules: MkRules.rules
	@cat MkRules.rules > MkRules
endif

CFLAGS = -O3 -Wall -pedantic $(EOPTS) $(LTO)
FFLAGS = -O3 $(EOPTS) $(GF7OPTS) $(LTO)

ifdef DEBUG
 CFLAGS += $(G_FLAG)
 FFLAGS += $(G_FLAG)
else
 DLLFLAGS += -s
endif


R-DLLFLAGS = -mwindows
LIBEXTRAS = -L"$(EXT_LIBS)"/lib$(R_ARCH) -lpcre2-8 -lz -lbz2 -llzma
ifdef USE_ICU
LIBEXTRAS += -L"$(ICU_PATH)"/lib$(R_ARCH) $(ICU_LIBS)
endif

dllversion-RESFLAGS = -I../include
CSOURCES = \
  console.c dynload.c editor.c embeddedR.c extra.c malloc.c \
  opt.c pager.c preferences.c psignal.c rhome.c rt_complete.c \
  rui.c run.c shext.c sys-win32.c system.c dos_wglob.c
OBJS = $(CSOURCES:.c=.o) dllversion.o
ifeq "$(WIN)" "32"
 OBJS += e_pow.o
endif
MAINLIBS = ../main/libmain.a ../appl/libappl.a ../nmath/libnmath.a
EXTRALIBS = getline/gl.a ../extra/xdr/libxdr.a \
   ../extra/intl/libintl.a ../extra/trio/libtrio.a ../extra/tzone/libtz.a \
   ../extra/tre/libtre.a

R-DLLLIBS = $(OPENMP) -L. $(FLIBS) -lRblas -L../../$(IMPDIR) -lRgraphapp \
  -lRiconv -lcomctl32 -lwinmm -lversion $(LIBEXTRAS)


.PHONY:  clean veryclean rlibs fixfiles front-ends rmodules


CPPFLAGS = -I../include -I. -I../extra -DHAVE_CONFIG_H -DR_DLL_BUILD
extra-CPPFLAGS = -I../library/grDevices/src

Rpwd.exe: front-ends/Rpwd.exe
	$(CP) $< $@

front-ends/Rpwd.exe:
	$(MK) -C front-ends Rpwd

## watch out: R.dll and Rblas.dll depend on each other.
rbuild:
	@$(MK) fixfiles
	@$(MK) -C ../include -f Makefile.win
	@$(MK) -C ../scripts -f Makefile.win
ifdef USE_IMPLIBS
	@$(MK) libRiconv.dll.a
endif
	@$(MK) libRblas.dll.a
	@$(MK) ../../$(BINDIR)/R.dll
ifdef USE_IMPLIBS
	@$(MK) implibs
endif
	@$(MK) Rblas
	@$(MK) front-ends COPYRIGHTS rmodules fixed/fixdesc


rlibs:
	$(MK) -C ../extra/intl CFLAGS='$(CFLAGS)' -f Makefile.win
	$(MK) -C ../appl CFLAGS='$(CFLAGS)' FFLAGS='$(FFLAGS)' -f Makefile.win
	$(MK) -C ../nmath CFLAGS='$(CFLAGS)' FFLAGS='${FFLAGS}' -f Makefile.win
	$(MK) -C ../main CFLAGS='$(CFLAGS)' FFLAGS='$(FFLAGS)' malloc-DEFS='$(malloc-DEFS)' -f Makefile.win
	$(MK) -C ./getline CFLAGS='$(CFLAGS)'
	@for ex in graphapp xdr tre trio tzone win_iconv ; do \
	  $(MK) -C ../extra/$${ex} CFLAGS='$(CFLAGS)' -f Makefile.win || exit 1; \
	done

rmodules:
	@$(MKDIR) -p ../../modules$(R_ARCH)
	$(MK) -C ../modules -f Makefile.win \
	  CFLAGS='$(CFLAGS)' FFLAGS='$(FFLAGS)'

COPYRIGHTS: ../../doc/COPYRIGHTS COPYRIGHTS.win
	cat $^ > $@


fixfiles: Rpwd.exe
	@$(MKDIR) -p ../../$(BINDIR)
	@$(MK) -C ./fixed
ifdef USE_LIBCURL
	@if test -f "$(CURL_PATH)/etc/curl-ca-bundle.crt"; then \
	  $(CP) -p "$(CURL_PATH)/etc/curl-ca-bundle.crt" ../../etc; \
	elif test -f "$(CURL_CA_BUNDLE)"; then \
	  $(CP) -p "$(CURL_CA_BUNDLE)" ../../etc/curl-ca-bundle.crt; \
	fi
endif

fixed/fixdesc:
	@sh fixed/GETDESC $(R_PKGS_BASE) translations

dllversion.o: ../include/Rversion.h

## Rdll.hide has decoration which 64-bit builds lack
ifeq "$(WIN)" "64"
R.dll: $(OBJS) $(MAINLIBS) $(EXTRALIBS)
	@$(ECHO) EXPORTS > R.def
	@$(NM) $^ | $(SED) -n  $(SYMPAT) | LC_COLLATE=C $(SORT) | \
	  uniq $(NM_FILTER) > R0.def
	@$(SED) -e's/@.*//' Rdll.hide | LC_COLLATE=C $(SORT) > R1.def
	@LC_COLLATE=C comm -23 R0.def R1.def >> R.def
	$(DLL) -shared $(DLLFLAGS) $($*-DLLFLAGS) -o $@ R.def $^ $($*-DLLLIBS) $(DLLLIBS)
	@$(RM) R.def R0.def R1.def
else
R.dll: $(OBJS) $(MAINLIBS) $(EXTRALIBS)
	@$(ECHO) EXPORTS > R.def
	@$(NM) $^ | $(SED) -n  $(SYMPAT) | LC_COLLATE=C $(SORT) | uniq > R0.def
	@LC_COLLATE=C $(SORT) Rdll.hide > R1.def
	@LC_COLLATE=C comm -23 R0.def R1.def >> R.def
	$(DLL) -shared $(DLLFLAGS) $($*-DLLFLAGS) -o $@ R.def $^ $($*-DLLLIBS) $(DLLLIBS)
	@$(RM) R.def R0.def R1.def
endif

R.exp: $(OBJS) $(MAINLIBS) $(EXTRALIBS)
	@$(ECHO) LIBRARY R.dll > R.exp
	@$(ECHO) EXPORTS >> R.exp
	@$(NM) $^ | $(SED) -n $(SYMPAT) | LC_COLLATE=C $(SORT) | \
	  uniq $(NM_FILTER) > R0.def
	@LC_COLLATE=C comm -23 R0.def Rdll.hide >> R.exp
	@$(RM) R0.def


Rdll: makeMakedeps libRblas.dll.a ../../$(BINDIR)/R.dll

../../$(BINDIR)/R.dll: FORCE
	@$(MK) fixfiles
	@$(MK) -C ../include -f Makefile.win
	@$(MK) rlibs
	@$(MK) makeMakedeps
	@$(MK) R.dll
	@$(MKDIR) -p ../../$(BINDIR)
	$(CP) R.dll ../../$(BINDIR)

FORCE:

implibs: libR.dll.a libRblas.dll.a
	@$(MKDIR) -p ../../lib
	@$(CP) $^ ../../lib

libR.dll.a: R.exp
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname R.dll \
	  --input-def $< --output-lib $@

libRiconv.dll.a: unicode/iconv.def
	$(DLLTOOL) $(DLLTOOLFLAGS) $(R-DLLTOOLFLAGS) --dllname Riconv.dll \
	  --input-def $< --output-lib $@


front-ends:
	$(MK) -C front-ends

../extra/tre/libtre.a:
	$(MK) -C ../extra/tre -f Makefile.win

../extra/trio/libtrio.a:
	$(MK) -C ../extra/trio -f Makefile.win

NEWSdocs:
	@$(MK) -C ../../doc -f Makefile.win

htmldocs:
	@$(ECHO)
	@$(ECHO) "------ Making HTML documentation ------"
	@$(MK) -C ../../doc/manual -f Makefile.win html


#                          ===== BLAS ======

Rblas:
	@$(MK) -C ../extra/blas -f Makefile.win FFLAGS='-O2 $(EOPTS)'

Rblas-clean:
	@$(MK) -C ../extra/blas -f Makefile.win clean

libRblas.dll.a:  ../extra/blas/Rblas.def
	@$(DLLTOOL) $(DLLTOOLFLAGS) --dllname Rblas.dll \
	  --input-def $< --output-lib $@


#                          ===== cleaning ======

## used in installer/Makefile
PKGDIR = ../library
pkgclean-%:
	@(cd $(PKGDIR)/$*/src; rm -f *.d *.o *.dll *_res.rc Makedeps)

EXTRA_DIRS = blas graphapp intl tre trio tzone xdr win_iconv

cleaninstaller:
	-$(MAKE) -C installer clean

# The installer has to be cleaned first, because cleaning it depends on Rscript
#   clean0 and cleanwin0 exclude the installer
#   clean, distclean and cleanwin clean also the installer 
clean0: cleanwin0
	@$(MAKE) -C ../library -f Makefile.win clean
	$(RM) -f ../*/*.o ../*/*.a *.a ../*/*.d ../*/Makedeps fixed/fixdesc
	@for d in $(EXTRA_DIRS); do \
	  $(MAKE) -C ../extra/$${d} -f Makefile.win clean; \
	done
	-$(MK) -C ../../doc/manual -f Makefile.win distclean
	-$(MK) -C ../nmath/standalone -f Makefile.win distclean
	-$(MK) -C ../modules -f Makefile.win clean
	-$(MK) -C ../../tests -f Makefile.win clean
	-$(MK) -C ../library/Recommended -f Makefile.win clean
	$(RM) -f ../library/methods/all.R ../../etc/curl-ca-bundle.crt

clean: cleaninstaller clean0

distcleaninstaller:
	-$(MAKE) -C installer distclean 

distclean: cleaninstaller distcleaninstaller clean0
	@for d in $(EXTRA_DIRS); do \
	  $(MAKE) -C ../extra/$${d} -f Makefile.win distclean; \
	done
	@$(MAKE) -C ../../tests -f Makefile.win distclean
	$(RM) -R ../../bin ../../include ../../lib ../../library ../../modules
	$(RM) ../include/config.h ../include/iconv.h ../include/psignal.h \
	../include/Rconfig.h ../include/Rversion.h ../include/Rmath.h \
	../include/libintl.h ../include/trioremap.h
	$(RM) ../library/*/src/*.o ../library/*/src/*.a
	$(RM) ../library/*/src/*.d ../library/*/src/Makedeps
	$(RM) ../library/*/src/*.dll
	$(RM) ../library/*/src/windows/*.o ../library/*/src/windows/*.a
	$(RM) ../library/*/src/windows/*.d ../library/*/src/windows/Makedeps
	$(RM) ../library/*/src/windows/*.dll
	$(RM) -R ../library/*/check
	$(RM) ../library/*/tests/*.ps ../library/*/tests/*.pdf
	$(RM) ../library/tcltk/src/tcl$(TCL_VERSION).def \
	../library/tcltk//src/tk$(TCL_VERSION).def
	$(RM) R.exp COPYRIGHTS
	$(RM) ../../doc/html/index.html \
	../../doc/html/packages.html ../../doc/html/rwin.html \
	../../doc/html/rw-FAQ.html ../../doc/html/NEWS.html \
	../../doc/NEWS.rds ../../doc/NEWS.3.rds ../../doc/NEWS.2.rds \
	../../doc/NEWS ../../doc/NEWS.pdf \
	../../doc/CHANGES.rds ../../doc/html/CHANGES.html
	$(RM) ../../etc/Makeconf ../../etc/Rconsole ../../etc/Rdevga \
	../../etc/Rprofile.site ../../etc/rgb.txt ../../etc/Rcmd_environ \
	../../tests/*.Rout ../../tests/*.Rout.fail
	$(RM) -R ../../etc/i386 ../../etc/x64 # do both sub-archs
	$(RM) -R ../../share/zoneinfo
	$(MAKE) -C fixed distclean
	$(MAKE) -C ../include -f Makefile.win distclean
	@for pkg in $(R_PKGS_BASE) translations; do \
	  $(RM) ../library/$${pkg}/DESCRIPTION; \
	done
	$(RM) ../../SVN-REVISION.bak
	$(RM) ../../doc/manual/rw-FAQ
	$(MAKE) -C cran clean
	$(RM) -R ../library/.vignettes # it gets left behind if there is an error
	$(RM) -R ../../share/locale # relic of earlier versions
	$(RM) MkRules Rpwd.exe # do this last of all

veryclean: distclean
	$(RM) ../../doc/FAQ ../../doc/RESOURCES ../../doc/NEWS.rds \
	  ../../doc/html/resources.html ../../doc/html/NEWS.html \
	  ../../SVN-REVISION # not in SVN sources

cleanwin0: MkRules fixfiles
	$(RM) *.o *.dll *.a *~ \#*\# .RData .Rhistory Makedeps *.d
	$(MAKE) -C ../extra/graphapp -f Makefile.win clean
	$(MAKE) -C fixed clean
	$(MAKE) -C getline clean
	$(MAKE) -C front-ends clean
	$(MAKE) -C ../library/grDevices/src/cairo -f Makefile.win clean WIN=$(WIN)

cleanwin: cleaninstaller cleanwin0


#                          ===== testing ======

check check-devel check-all check-recommended:
	@$(MK) -C ../../tests -f Makefile.win $@

#                          ===== documentation ======

pdfdocs manuals:
	@$(MK) -C ../../doc/manual -f Makefile.win clean
	@$(MK) -C ../../doc/manual -f Makefile.win

R_EXE = ../../$(BINDIR)/Rterm.exe --vanilla --no-echo

## must come after recommended
vignettes:
	@$(MK) -C ../library -f Makefile.win vignettes


## ===================== Maintainer targets ========================

RVER-PAT = $(shell version=`cut -d' ' -f1 ../../VERSION | sed -n 1p`; if test "`cut -f2 -d' ' ../../VERSION`" = "Patched"; then version=`echo $${version} | sed 's/\.[0-9]*$$//'`; echo "$${version}-patched"; else echo "$${version}"; fi)

CRANREC = cran.r-project.org::CRAN/src/contrib/$(RVER-PAT)/Recommended

## Use -c here to avoid re-downloading the same versions of files
## A recent rsync seems to need -p
rsync-recommended:
	@(cd ../library; \
	  rsync --timeout=60 -rcvpC --delete \
	    --exclude=Makefile.in --exclude=Makefile.win --exclude=.cvsignore \
	    --include=*.tar.gz --exclude=*.tgz --exclude=*.ts \
	    --exclude=".svn" $(CRANREC) . )
	@$(RM) ../library/Recommended/*.tgz
	@(cd ../library/Recommended; for i in ${R_PKGS_RECOMMENDED}; do cp -p $${i}*.tar.gz $${i}.tgz ; done)

link-recommended:
	@$(RM) ../library/Recommended/*.tgz
	@(cd ../library/Recommended; for i in ${R_PKGS_RECOMMENDED} ; do cp -p $${i}*.tar.gz $${i}.tgz ; done)


recommended:
	@$(ECHO) "--- Making recommended packages"
	@$(MK) -C ../library/Recommended -f Makefile.win

## Note that R_COMPILER_SUPPRESS_ALL is now on by default
bytecode-recommended:
	@$(ECHO) "--- Making and compiling recommended packages"
	@rm ../library/Recommended/*.ts
	@R_COMPILE_PKGS=1 R_COMPILER_SUPPRESS_ALL=1 \
	  $(MK) -C ../library/Recommended -f Makefile.win

=== src/gnuwin32/fixed/Makefile ===
include ../MkRules

R_HOME = ../../..

# FIXME:  Should find a make where $(abspath ...) works and avoid this...
LOCAL_SOFT := $(shell ../Rpwd.exe $(LOCAL_SOFT))

all: profiles fixhtml fixetc fixdoc svnonly

profiles: $(R_HOME)/library/base/R/Rprofile

$(R_HOME)/library/base/R/Rprofile:  ../../library/profile/Common.R \
../../library/profile/Rprofile.windows
	@$(ECHO) -------- Building $@ from $^--------
	mkdir -p $(R_HOME)/library/base/R
	@$(CAT)  $^ > $@

fixhtml:  html/rwin.html
	$(CP) -p html/rwin.html $(R_HOME)/doc/html/index.html
	@$(ECHO) done > fixhtml

ETC = $(wildcard ./etc/*)
fixetc: $(ETC) ../MkRules Makefile
	$(CP) -p $(ETC) $(R_HOME)/etc
	$(RM) $(R_HOME)/etc/Makeconf
	$(MKDIR) -p $(R_HOME)/etc/$(R_ARCH)
ifeq "$(WIN)" "64"
	$(SED) -e 's/WIN = 32/WIN = 64/' \
	  -e "s/-O3/-O2/" \
	  -e "s/@EOPTS@/$(EOPTS)/" \
	  -e "s|BINPREF =|BINPREF ?= $(BINPREF)|" \
	  -e "s|COMPILED_BY =|COMPILED_BY = $(COMPILED_BY)|" \
	  -e "s|IMPDIR = bin|IMPDIR = $(IMPDIR)|" \
	  -e "s|LOCAL_SOFT ?=|LOCAL_SOFT ?= $(LOCAL_SOFT)|" \
	  -e "s|R_ARCH =|R_ARCH = $(R_ARCH)|" \
	  -e "s|DT_ARCH =|DT_ARCH = $(DT_ARCH)|" \
	  -e "s|RC_ARCH =|RC_ARCH = $(RC_ARCH)|" \
	  -e "s|M_ARCH =|M_ARCH = $(M_ARCH)|" \
	  -e "s|@SYMPAT@|$(SYMPAT)|" \
	  -e "s|(TCL_HOME)/bin|(TCL_HOME)/bin64|" \
	  -e "s|@OPENMP@|$(OPENMP)|" \
	  -e "s|@PTHREAD@|$(PTHREAD)|" \
	  -e "s@NM_FILTER =@NM_FILTER = $(NM_FILTER)@" \
	  -e "s|@GF7OPTS@|$(GF7OPTS)|" \
	  -e "s|LTO =|LTO = $(LTO)|" \
	  -e "s|LTO_OPT =|LTO_OPT = $(LTO_OPT)|" \
	  etc/Makeconf > $(R_HOME)/etc$(R_ARCH)/Makeconf
else
	$(SED) -e "s|IMPDIR = bin|IMPDIR = $(IMPDIR)|" \
	  -e "s/-O3/-O2/" \
	  -e "s/@EOPTS@/$(EOPTS)/" \
	  -e "s|BINPREF =|BINPREF ?= $(BINPREF)|" \
	  -e "s|COMPILED_BY =|COMPILED_BY = $(COMPILED_BY)|" \
	  -e "s|LOCAL_SOFT ?=|LOCAL_SOFT ?= $(LOCAL_SOFT)|" \
	  -e "s|R_ARCH =|R_ARCH = $(R_ARCH)|" \
	  -e "s|DT_ARCH =|DT_ARCH = $(DT_ARCH)|" \
	  -e "s|RC_ARCH =|RC_ARCH = $(RC_ARCH)|" \
	  -e "s|M_ARCH =|M_ARCH = $(M_ARCH)|" \
	  -e "s|@SYMPAT@|$(SYMPAT)|" \
	  -e "s|@OPENMP@|$(OPENMP)|" \
	  -e "s|@PTHREAD@|$(PTHREAD)|" \
	  -e "s@NM_FILTER =@NM_FILTER = $(NM_FILTER)@" \
	  -e "s|@GF7OPTS@|$(GF7OPTS)|" \
	  -e "s|LTO =|LTO = $(LTO)|" \
	  -e "s|LTO_OPT =|LTO_OPT = $(LTO_OPT)|" \
	  etc/Makeconf > $(R_HOME)/etc$(R_ARCH)/Makeconf
endif
	$(SED) -e "s+@BINDIR@+$(BINDIR)+" Makeconf > $(R_HOME)/Makeconf
	@$(ECHO) done > fixetc

fixdoc: $(wildcard ../CHANGES?)
	$(CP) -p $^ $(R_HOME)/doc
	@$(ECHO) done > fixdoc

svnonly:
	@$(MAKE) -C ../../../doc/manual -f Makefile.win svnonly

clean:
	$(RM) *~ */*~ fixhtml fixbin fixetc fixshare fixdoc

distclean:
	$(RM) $(R_HOME)/doc/CHANGES* $(R_HOME)/Makeconf

=== src/gnuwin32/installer/Makefile ===
# Makefile for R for Windows Installers

include ../MkRules

## Formerly in MkRules
FIND = find

R_HOME = ../../..
include $(R_HOME)/share/make/vars.mk

## use this to install other packages from main library
EXTRA_PKGS =

## Default display mode, 0=MDI, 1=SDI
MDISDI = 0

## Default help style, 0=plain text, 1=HTML
HelpStyle = 1

## Used to set Registry entries
Producer = R-core

ifeq "$(WIN)" "64"
ifneq ($(strip $(HOME32)),)
SUFF = win
else
SUFF = win64
endif
else
SUFF = win32
endif

FULLVERSION=`cat ../../../VERSION`
RPREFIX = $(shell ../../../bin$(R_ARCH)/Rscript ../fixed/rwver.R)
LIBFILES = $(foreach i, $(R_PKGS_BASE) $(R_PKGS_RECOMMENDED) translations $(EXTRA_PKGS), $(R_HOME)/library/$i)

INFO_FILES = COPYING README
DOC_INFO_FILES = AUTHORS COPYING FAQ RESOURCES THANKS CHANGES \
  NEWS NEWS.0 NEWS.1 NEWS.2 
GW_INFO_FILES = COPYRIGHTS README.Rterm ../../doc/manual/rw-FAQ

ETC_FILES = Rprofile.site Rconsole Rdevga rgb.txt repositories Rcmd_environ


# we don't want share/{Makefile.in,java,sh} installed
SHARE_DIRS = R dictionaries encodings licenses make Rd texmf zoneinfo

all: $(RPREFIX)-win.exe
msi: $(RPREFIX)-$(SUFF).msi

imagedir:
	$(RM) -R $(RPREFIX)
	$(MKDIR) $(RPREFIX)
	$(CP) -pR $(R_HOME)/bin $(R_HOME)/modules $(RPREFIX)
# copy base and recommended packages
	$(MKDIR) -p $(RPREFIX)/library
	$(CP) -pR $(LIBFILES) $(RPREFIX)/library
	$(RM) $(RPREFIX)/library/*/MD5
	$(RM) $(RPREFIX)/*/Makefile.in
	$(MKDIR) -p $(RPREFIX)/etc$(R_ARCH)
	$(CP) -p $(foreach i,$(ETC_FILES),$(R_HOME)/etc/$i) $(RPREFIX)/etc
	if test -f "$(R_HOME)/etc/curl-ca-bundle.crt"; then \
	  $(CP) -p "$(R_HOME)/etc/curl-ca-bundle.crt" $(RPREFIX)/etc; \
	fi
	$(CP) -p $(R_HOME)/etc$(R_ARCH)/Makeconf $(RPREFIX)/etc$(R_ARCH)
# copy info and documentation files
	$(MKDIR) -p $(RPREFIX)/doc
	$(CP) -p $(R_HOME)/doc/CRAN_mirrors.csv $(RPREFIX)/doc
	$(CP) -p $(R_HOME)/doc/BioC_mirrors.csv $(RPREFIX)/doc
	$(MKDIR) -p $(RPREFIX)/doc/manual/images
	$(CP) -pR $(R_HOME)/doc/html $(RPREFIX)/doc
	$(CP) -p $(R_HOME)/doc/manual/*.html $(R_HOME)/doc/manual/*.pdf \
	  $(RPREFIX)/doc/manual
	$(CP) -p $(R_HOME)/doc/manual/images/*.png $(RPREFIX)/doc/manual/images
#	html copies of these are in doc/manual, and we don't have FAQ PDF on menus
	$(RM) $(RPREFIX)/doc/manual/R-FAQ.pdf
	$(RM) $(RPREFIX)/doc/html/R-admin.html 
	$(RM) $(RPREFIX)/doc/html/index-default.html
#
	$(CP) -p $(foreach i,$(INFO_FILES),$(R_HOME)/$i) $(RPREFIX)
	$(CP) -p $(foreach i,$(DOC_INFO_FILES),$(R_HOME)/doc/$i) $(RPREFIX)/doc
	$(CP) -p $(foreach i,$(GW_INFO_FILES),../$i) $(RPREFIX)/doc
	$(CP) -p $(RPREFIX)/doc/CHANGES $(RPREFIX)
	$(SED) -e s/@RWVER@/$(RPREFIX)/g \
	  -e s/@RVER@/$(RVER)/g \
	  -e "s/@FULLVERSION@/$(FULLVERSION)/g" ../README > $(RPREFIX)/README.$(RPREFIX)
	$(SED) -e 3,5d ../README.packages > $(RPREFIX)/doc/README.packages
# convert docs and batch files to CRLF: might already be on Windows, though.
	zip -q dosfiles.zip $(RPREFIX)/* $(RPREFIX)/doc/*
	unzip -qao dosfiles.zip
	$(RM) dosfiles.zip
	$(CP) -p $(R_HOME)/doc/NEWS.pdf $(RPREFIX)/doc
	$(CP) -p $(R_HOME)/doc/NEWS.rds $(R_HOME)/doc/NEWS.2.rds  $(R_HOME)/doc/NEWS.3.rds $(R_HOME)/doc/CHANGES.rds $(RPREFIX)/doc
#
# files to make source packages
	$(MKDIR) -p $(RPREFIX)/share \
	  $(RPREFIX)/src/library $(RPREFIX)/src/gnuwin32
	$(CP) $(R_HOME)/doc/html/logo.jpg $(R_HOME)/doc/html/Rlogo.svg $(RPREFIX)/doc/html
	$(CP) $(R_HOME)/doc/KEYWORDS* $(RPREFIX)/doc
	$(CP) -pR $(R_HOME)/include $(RPREFIX)
	$(CP) -pR $(foreach i,$(SHARE_DIRS),$(R_HOME)/share/$i) $(RPREFIX)/share
# This is odd -- better to clean the copy
	(cd ..; $(MAKE) --no-print-directory PKGDIR=. pkgclean-windlgs)
	$(CP) -pR ../windlgs $(RPREFIX)/src/library
ifeq "$(WIN)" "64" 	
# Edit Makeconf
	$(SED) -e 's!^BINPREF [?]= .*!BINPREF ?= "$$(RTOOLS40_ROOT)/mingw64/bin/"!' \
	  $(R_HOME)/etc/x64/Makeconf > $(RPREFIX)/etc/x64/Makeconf
endif	  
# test dir
	mkdir $(RPREFIX)/tests
	$(MAKE) --no-print-directory -C ../../../tests -f Makefile.win \
	  INST_TO=../src/gnuwin32/installer/$(RPREFIX)/tests install-tests
#
	$(FIND) $(RPREFIX) -name .svn -prune -exec rm -Rf \{\} \;
	$(FIND) $(RPREFIX) -name \*~ -delete

md5sums:
	@echo "adding MD5 checksums"
	@(cd $(RPREFIX); echo "tools:::.installMD5sums(\".\")" | \
	  R_DEFAULT_PACKAGES=NULL LC_COLLATE=C R_OSTYPE=windows \
	  ../../../../$(BINDIR)/Rterm.exe --vanilla --no-echo)

PDF_FILES = $(wildcard $(RPREFIX)/library/*/doc/*.pdf)

fixups:
	echo "make.packages.html(.Library,temp=FALSE,verbose=FALSE)" | $(RPREFIX)/$(BINDIR)/Rterm.exe --vanilla --no-echo LC_COLLATE=C
	$(CP) -pRf $(R_HOME)/Tcl $(RPREFIX)
	$(RM) $(RPREFIX)/Tcl*/lib/*.lib
ifneq ($(strip $(QPDF)),)
	@for f in $(PDF_FILES); do \
	  $(QPDF)/bin/qpdf $${f} tmp.pdf; \
	  mv tmp.pdf $${f}; \
	done
endif

32bit:
ifeq "$(WIN)" "64"
ifneq ($(strip $(HOME32)),)
	@echo "------------ including 32-bit files"
	(cd "$(HOME32)"; zip -qr9X 32bit */i386 library/*/libs/i386 bin/R.exe bin/Rscript.exe)
	unzip -qo "$(HOME32)/32bit" -d $(RPREFIX)
	rm "$(HOME32)/32bit.zip"
	mkdir -p $(RPREFIX)/Tcl
	$(CP) -pRf "$(HOME32)/Tcl/bin" "$(HOME32)/Tcl/lib" $(RPREFIX)/Tcl
	for f in $(R_PKGS_RECOMMENDED); do \
	   sed -e 's/Archs: x64/Archs: i386, x64/' \
             ../../../library/$${f}/DESCRIPTION \
             > $(RPREFIX)/library/$${f}/DESCRIPTION; \
	done
# Edit Makeconf file to default Rtools location
	$(SED) -e 's!^BINPREF [?]= .*!BINPREF ?= "$$(RTOOLS40_ROOT)/mingw32/bin/"!' \
	  $(HOME32)/etc/i386/Makeconf > $(RPREFIX)/etc/i386/Makeconf
else
	@echo "------------ not including 32-bit files"
endif
endif

extras:
	for f in $(DLLs32); do \
	  cp "$$f" $(RPREFIX)/bin/i386; \
	done
	for f in $(DLLs64); do \
	  cp "$$f" $(RPREFIX)/bin/x64; \
	done

## for Inno Setup installer

R.iss: JRins.R header1.iss types3264.iss types32.iss types64.iss code.iss \
   reg.iss reg3264.iss reg64.iss \
   CustomMsg.iss imagedir fixups 32bit extras md5sums \
  ../../../VERSION ../../../SVN-REVISION
	../../../bin$(R_ARCH)/Rscript JRins.R \
	  $(RPREFIX) $(RPREFIX) $(MDISDI) \
	  $(HelpStyle) $(Producer) "$(ISDIR)"

$(RPREFIX)-win.exe: R.iss
	"$(ISDIR)/iscc" R.iss > $(RPREFIX).log 2>&1


## for MSI installer

uuidgen.exe: uuidgen.o
	$(CC) -o $@ $< -lole32

# currently use about 3500: allow for EXTRA_PKGS
uuids: uuidgen.exe
	./uuidgen 10000 > $@

files.wxs: imagedir fixups 32bit extras md5sums
	"$(WIX3DIR)/heat" dir $(RPREFIX) -sw5150 -nologo -o $@

R.wxs: WIXins.R uuids files.wxs
	../../../bin$(R_ARCH)/Rscript WIXins.R $(RPREFIX) $(RPREFIX) $(WIX_PERSONAL) || (rm -f $@;exit 1)

$(RPREFIX)-$(SUFF).msi: R.wxs License.rtf
	"$(WIX3DIR)/candle" R.wxs > $(RPREFIX).log 2>&1
	"$(WIX3DIR)/light" -out $@ R.wixobj -dcl:high \
	 -ext WixUIExtension -sw1076 -sval -spdb >> $(RPREFIX).log 2>&1


## too often this fails to empty directories.
clean:
	rm -Rf R.iss *.log R.wxs files.wxs R.wixobj uuidgen.o uuidgen.exe uuids
	-rm -Rf $(RPREFIX)

distclean: clean
	rm -f R*-win*.exe R*-win*.msi

myR:
	echo "make.packages.html(.Library, verbose=FALSE)" | "$(IMAGEDIR)/$(BINDIR)/Rterm.exe" --vanilla --no-echo LC_COLLATE=C
	@echo "adding MD5 checksums"
	@(cd "$(IMAGEDIR)"; echo "tools:::.installMD5sums(\".\")" | \
	  R_DEFAULT_PACKAGES=NULL LC_COLLATE=C R_OSTYPE=windows \
	  "$(IMAGEDIR)/$(BINDIR)/Rterm.exe" --vanilla --no-echo)
	../../../bin$(R_ARCH)/Rscript JRins.R \
	  $(RPREFIX) "$(IMAGEDIR)" $(MDISDI) \
	  $(HelpStyle) $(Producer) "$(ISDIR)"
	"$(ISDIR)/iscc" R.iss > myR.log

=== src/gnuwin32/windlgs/DESCRIPTION ===
Package: windlgs
Version: 1.1.0
Title: Examples of Windows Dialogs
Author: R Core Team
Maintainer: R Core Team <R-core@r-project.org>
Description: Examples of Windows Dialogs
Imports: stats
License: GPL (>=2)

=== debian/changelog ===
r-base (4.1.2-1ubuntu2) jammy; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Feb 2022 05:35:18 +0100

r-base (4.1.2-1ubuntu1) jammy; urgency=medium

  * Drop adding -std=gnu99, as R needs at least C11 compiler by default
    and adds -std=gnu11 which then lowers the standard than what gcc
    default is.
  * Turn off LTO as it missbuilds R with HAVE_FORTRAN_DOUBLE_COMPLEX not
    defined. LP: #1950283

 -- Dimitri John Ledkov <dimitri.ledkov@canonical.com>  Tue, 09 Nov 2021 12:11:18 +0000

r-base (4.1.2-1) unstable; urgency=medium

  * New upstream version released this morning

  * debian/control: Set Standards-Version: to current version 

 -- Dirk Eddelbuettel <edd@debian.org>  Mon, 01 Nov 2021 06:00:06 -0500

r-base (4.1.1-2) unstable; urgency=medium

  * Binary rebuild for unstable following Debian 11 release

 -- Dirk Eddelbuettel <edd@debian.org>  Sun, 15 Aug 2021 08:53:59 -0500

=== debian/control ===
Source: r-base
Section: gnu-r
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dirk Eddelbuettel <edd@debian.org>
Standards-Version: 4.6.0
Build-Depends: gcc (>= 4:4.9.2-2), g++ (>= 4:4.9.2-2), gfortran  (>= 4:4.9.2-2), libblas-dev, liblapack-dev, tcl8.6-dev, tk8.6-dev, bison, groff-base, libncurses5-dev, libreadline-dev, debhelper-compat (= 11), texinfo (>= 4.1-2), libbz2-dev, liblzma-dev, libpcre2-dev, libpcre3-dev, libcurl4-openssl-dev | libcurl4-dev, xdg-utils, zlib1g-dev, libpng-dev, libjpeg-dev, libx11-dev, libxt-dev, x11proto-core-dev, libpango1.0-dev, libcairo2-dev, libtiff5-dev, xvfb, xauth, xfonts-base, texlive-base, texlive-latex-base, texlive-plain-generic, texlive-fonts-recommended, texlive-fonts-extra, texlive-extra-utils, texlive-latex-recommended, texlive-latex-extra, default-jdk [!arm !hppa !kfreebsd-i386 !kfreebsd-amd64 !hurd-i386] | openjdk-10-jdk [!arm !hppa !kfreebsd-i386 !kfreebsd-amd64 !hurd-i386], mpack, bash-completion
Vcs-Browser: https://salsa.debian.org/edd/r-base
Vcs-Git: https://salsa.debian.org/edd/r-base.git
Homepage: http://www.r-project.org/

Package: r-base
Architecture: all
Depends: ${misc:Depends}, r-base-core (>= ${source:Version}), r-recommended (= ${source:Version})
Recommends: r-base-html, r-doc-html
Suggests: elpa-ess, r-doc-info | r-doc-pdf  
Description: GNU R statistical computation and graphics system
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger, 
 access to certain system functions, and the ability to run programs 
 stored in script files.
 .
 The design of R has been heavily influenced by two existing languages:
 Becker, Chambers & Wilks' S and Sussman's Scheme.  Whereas the 
 resulting language is very similar in appearance to S, the underlying 
 implementation and semantics are derived from Scheme.
 .
 The core of R is an interpreted computer language which allows 
 branching and looping as well as modular programming using functions.  
 Most of the user-visible functions in R are written in R.  It is 
 possible for the user to interface to procedures written in the 
 C, C++, or FORTRAN languages for efficiency, and many of R's core 
 functions do so.  The R distribution contains functionality for a 
 large number of statistical procedures and underlying applied math 
 computations.  There is also a large set of functions which provide 
 a flexible graphical environment for creating various kinds of data 
 presentations. 
 .
 Additionally, several thousand extension "packages" are available from 
 CRAN, the Comprehensive R Archive Network, many also as Debian packages, 
 named 'r-cran-<name>'.
 .
 This package is a metapackage which eases the transition from the 
 pre-1.5.0 package setup with its larger r-base package. Once installed, it 
 can be safely removed and apt-get will automatically upgrade its components
 during future upgrades.  Providing this package gives a way to users to 
 then only install r-base-core if they so desire.

Package: r-base-core
Architecture: any
Depends: ${misc:Depends}, ${perl:Depends}, zip, unzip, libpaper-utils, xdg-utils, ${shlibs:Depends}, ucf (>= 3.0), ca-certificates
Replaces: r-base (<= 1.4.1-1), r-recommended (<< 1.9.0), r-gnome (<= 2.3.1), r-cran-rcompgen (<= 0.1-17-1), r-base-latex (<= 2.9.2-4)
Provides:  r-gnome, r-cran-rcompgen, r-base-latex, r-api-4.0
Conflicts:  r-gnome, r-cran-rcompgen, r-base-latex
Recommends: r-recommended, r-base-dev, r-doc-html
Suggests: elpa-ess, r-doc-info | r-doc-pdf, r-mathlib, r-base-html
Breaks: r-bioc-graph (<< 1.62.0-1~),
        r-cran-bbmle (<< 1.0.20-5~),
        r-cran-biocmanager (<< 1.30.4+dfsg-2~),
        r-cran-caret (<< 6.0-84-2~),
        r-cran-cmprsk (<< 2.2-8-1~),
        r-cran-coin (<< 1.3-0-1~),
        r-cran-dendextend (<< 1.12.0+dfsg-1~),
        r-cran-fields (<< 9.8-3-1~),
        r-cran-filehash (<< 2.4-2-2~),
        r-cran-future (<< 1.14.0+dfsg-1~),
        r-cran-genetics (<< 1.3.8.1.2-1~),
        r-cran-haplo.stats (<< 1.7.9-4~),
        r-cran-igraph (<< 1.2.4.1-1~),
        r-cran-lava (<< 1.6.5-1~),
        r-cran-libcoin (<< 1.0-4-1~),
        r-cran-msm (<< 1.6.7-1~),
        r-cran-permute (<< 0.9-5-1~),
        r-cran-phangorn (<< 2.5.5-1~),
        r-cran-popepi (<< 0.4.7-1~),
        r-cran-recipes (<< 0.1.6-1~),
        r-cran-sp (<< 1:1.3-1-2~),
        r-cran-spam (<< 2.2-2-1~),
        r-cran-units (<< 0.6-3-1~),
        r-cran-vegan (<< 2.5-5+dfsg-1~),
        r-cran-zelig (<< 5.1.6.1-1~)
Description: GNU R core of statistical computation and graphics system
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger, 
 access to certain system functions, and the ability to run programs 
 stored in script files.
 .
 The design of R has been heavily influenced by two existing languages:
 Becker, Chambers & Wilks' S and Sussman's Scheme.  Whereas the 
 resulting language is very similar in appearance to S, the underlying 
 implementation and semantics are derived from Scheme.
 .
 The core of R is an interpreted computer language which allows 
 branching and looping as well as modular programming using functions.  
 Most of the user-visible functions in R are written in R.  It is 
 possible for the user to interface to procedures written in the 
 C, C++, or FORTRAN languages for efficiency, and many of R's core 
 functions do so.  The R distribution contains functionality for a 
 large number of statistical procedures and underlying applied math 
 computations.  There is also a large set of functions which provide 
 a flexible graphical environment for creating various kinds of data 
 presentations. 
 .
 Additionally, several thousand extension "packages" are available
 from CRAN, the Comprehensive R Archive Network, many also as Debian
 packages, named 'r-cran-<name>'.
 .
 This package provides the core GNU R system from which only the optional
 documentation packages r-base-html, r-doc-html, r-doc-pdf and r-doc-info 
 have been split off to somewhat reduce the size of this package. 

Package: r-base-dev
Architecture: all
Depends: ${misc:Depends}, r-base-core (>= ${source:Version}), build-essential, gcc, g++, gfortran, libblas-dev | libatlas-base-dev, liblapack-dev | libatlas-base-dev, libncurses5-dev, libreadline-dev, libjpeg-dev, libpcre2-dev, libpcre3-dev, libpng-dev, zlib1g-dev, libbz2-dev, liblzma-dev, libicu-dev, xauth, pkg-config
Suggests: texlive-base, texlive-latex-base, texlive-plain-generic, texlive-fonts-recommended, texlive-fonts-extra, texlive-extra-utils, texlive-latex-recommended, texlive-latex-extra, texinfo
Description: GNU R installation of auxiliary GNU R packages 
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger, 
 access to certain system functions, and the ability to run programs 
 stored in script files.
 .
 The design of R has been heavily influenced by two existing languages:
 Becker, Chambers & Wilks' S and Sussman's Scheme.  Whereas the 
 resulting language is very similar in appearance to S, the underlying 
 implementation and semantics are derived from Scheme.
 .
 The core of R is an interpreted computer language which allows 
 branching and looping as well as modular programming using functions.  
 Most of the user-visible functions in R are written in R.  It is 
 possible for the user to interface to procedures written in the 
 C, C++, or FORTRAN languages for efficiency, and many of R's core 
 functions do so.  The R distribution contains functionality for a 
 large number of statistical procedures and underlying applied math 
 computations.  There is also a large set of functions which provide 
 a flexible graphical environment for creating various kinds of data 
 presentations. 
 .
 Additionally, several thousand extension "packages" are available from 
 CRAN, the Comprehensive R Archive Network, many also as Debian packages, 
 named 'r-cran-<name>'.
 .
 This package ensures that other Debian packages needed for installation of
 some auxiliary R packages are installed.

Package: r-mathlib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: r-base-core (= ${binary:Version}), r-base-dev (= ${binary:Version})
Description: GNU R standalone mathematics library
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger, 
 access to certain system functions, and the ability to run programs 
 stored in script files.
 .
 The design of R has been heavily influenced by two existing languages:
 Becker, Chambers & Wilks' S and Sussman's Scheme.  Whereas the 
 resulting language is very similar in appearance to S, the underlying 
 implementation and semantics are derived from Scheme.
 .
 The core of R is an interpreted computer language which allows 
 branching and looping as well as modular programming using functions.  
 Most of the user-visible functions in R are written in R.  It is 
 possible for the user to interface to procedures written in the 
 C, C++, or FORTRAN languages for efficiency, and many of R's core 
 functions do so.  The R distribution contains functionality for a 
 large number of statistical procedures and underlying applied math 
 computations.  There is also a large set of functions which provide 
 a flexible graphical environment for creating various kinds of data 
 presentations. 
 .
 Additionally, several thousand extension "packages" are available from 
 CRAN, the Comprehensive R Archive Network, many also as Debian packages, 
 named 'r-cran-<name>'.
 .
 This package provides the libRmath shared and static libraries which can
 be called from standalone C or C++ code.

Package: r-base-html
Architecture: all
Priority: optional
Section: doc
Depends: ${misc:Depends}, r-base-core
Replaces: r-base (<= 1.4.1-1), r-recommended (<< 1.9.0)
Suggests: r-doc-html, mozilla | www-browser
Description: GNU R html docs for statistical computing system functions
 R is a system for statistical computation and graphics.  It consists 
 of a language plus a run-time environment with graphics, a debugger, 
 access to certain system functions, and the ability to run programs 
 stored in script files.
 .
 The design of R has been heavily influenced by two existing languages:
 Becker, Chambers & Wilks' S and Sussman's Scheme.  Whereas the 
 resulting language is very similar in appearance to S, the underlying 
 implementation and semantics are derived from Scheme.
 .
 The core of R is an interpreted computer language which allows 
 branching and looping as well as modular programming using functions.  
 Most of the user-visible functions in R are written in R.  It is 
 possible for the user to interface to procedures written in the 
 C, C++, or FORTRAN languages for efficiency, and many of R's core 
 functions do so.  The R distribution contains functionality for a 
 large number of statistical procedures and underlying applied math 
 computations.  There is also a large set of functions which provide 
 a flexible graphical environment for creating various kinds of data 
 presentations. 
 .
 Additionally, several thousand extension "packages" are available from 
 CRAN, the Comprehensive R Archive Network, many also as Debian packages, 
 named 'r-cran-<name>'.
 .
 This package provides html documentation suitable for browsing with a 
 web-browser for the libraries included in the r-base package. It is not 
 a required package as the same documentation is already included for 
 on-line browsing. 

Package: r-doc-pdf
Architecture: all
Section: doc
Depends: ${misc:Depends}
Suggests: r-base-core, xdg-utils | pdf-viewer
Description: GNU R pdf manuals for statistical computing system
 R is a system for statistical computation and graphics.  It consists

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules file for the Debian GNU/Linux r-base package
# Copyright 1997-2003  Douglas Bates <bates@stat.wisc.edu>
# Copyright 1998-2019  Dirk Eddelbuettel <edd@debian.org>
#
# $Id: rules,v 1.3 2007/05/06 17:13:23 edd Exp edd $

corepackage	= r-base-core
devpackage	= r-base-dev
#latexpackage	= r-base-latex
pdfpackage	= r-doc-pdf
htmlpackage	= r-doc-html
nmathpackage	= r-mathlib
infopackage	= r-doc-info
recdpackage	= r-recommended
dbugpackage	= r-base-core-dbg

# for the standalone library, no sonames are assigned in the upstream Makefiles
somaj		= 1
somin		= 0
sorel		= 0
libver		= $(somaj).$(somin).$(sorel)

debbase		:= $(CURDIR)/debian
debtmp		:= $(debbase)/$(corepackage)
debdoc		:= $(debbase)/$(corepackage)/usr/share/doc/$(corepackage)
debmat		:= $(debbase)/$(nmathpackage)
debetc		:= $(debbase)/$(corepackage)/usr/lib/R/etc
debinf		:= $(debbase)/$(infopackage)
debcnf		:= $(debbase)/$(corepackage)/etc/R

## edd 24 Oct 2005 use DEB_BUILD_GNU_CPU, not DEB_BUILD_GNU_TYPE
##                 updated rules throughout
arch		:= $(shell dpkg-architecture -qDEB_BUILD_GNU_CPU)
buildarch	:= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
## edd 26 Jul 2013 also use DEB_HOST_ARCH_OS to catch kFreeBSD
buildos         := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
#export DH_VERBOSE = 1

# edd 15 Aug 2001  default to blas, atlas can override it
#atlas		= --with-blas=blas
# dmb 04 Apr 2003  better to use no specify blas
# atlas			= --with-blas
# edd 28 Apr 2003  try configuring with atlas
# atlas		= --with-blas=atlas
# edd 16 Oct 2003  back to older default
#atlas		= --with-blas=blas
# edd 26 Feb 2004  point to refblas3
#atlas		= --with-blas=-lblas-3
# edd 05 Feb 2008  default blas
atlas           = --with-blas

# edd 08 Mar 2003  use the new lapack feature
# edd 27 Apr 2003  Set this to =no as we currently see numerical errors
#lapack		= --with-lapack=no
# edd 26 Feb 2004  point to lapack3
#lapack		= --with-lapack=-llapack-3
# edd 13 Oct 2004  Set this once again to =no as we still see numerical errors
#lapack		= --with-lapack=no
# edd 05 Feb 2008  switched back
# edd 05 Feb 2008  oh, no switch back to internal lapack -- see #464833
#lapack		= --with-lapack=no
# edd 05 Mar 2008  with lapack as we can now use lapack 3.1 in unstable
lapack		= --with-lapack

# edd 02 Sep 2001  default to g77 but let m68k use f2c
# edd 06 Mar 2003  enforce 3.2 versions explicitly
#		   so that on testing we will pick them over 2.95
# edd 07 Jun 2003  let's fall back to the default compilers
# edd 08 Sep 2005  real defaults, i.e. remove -3.4 strings
# edd 03 Apr 2006  switch to gfortran
# edd 04 Apr 2006  use optimflags, build per-compiler flags later
# edd 26 Jun 2007  need 4.2 for fortran linking
# edd 26 Nov 2007  4.2 is now default, so no longer set -4.2 explictly; also add f95compiler
# edd 11 Oct 2011  setting -std=gnu99 with compiler (thanks, Kurt Hornik)
# edd 09 Nov 2021  R needs at least C11 or higher now, drop gnu99 settings
fortrancompiler	= F77=gfortran
f95compiler     = gfortran
# edd 10 Jan 2016  mips currently needs gcc-4.9 (cf #810357) and big thanks to Sébastien Villemot
# edd 12 Apr 2016  mips treatment removed again after kernel fix on
#ifeq ($(arch),mips)
#compiler	= "gcc-4.9"
#else
compiler	= gcc
#endif
cxxcompiler	= g++

# edd 31 Mar 2014
#optimflags	= -O3 -pipe
optimflags      = $(shell DEB_BUILD_MAINT_OPTIONS=optimize=-lto dpkg-buildflags --get CFLAGS)
# edd 08 Apr 2014  add CPPFLAGS
optimflags      += $(shell DEB_BUILD_MAINT_OPTIONS=optimize=-lto dpkg-buildflags --get CPPFLAGS)

# edd 22 Apr 2012  gcc-4.7 needs -O2 to build R (also #67359)
ifneq "$(shell gcc --version | head -1 | cut -d' ' -f4 | grep '^4.7')" ""
optimflags = -O2 -pipe
endif

# edd 04 Sep 2001  default compiler flags, lowered for m68k
#compilerflags	= -O2
# m68k barks when using g77, and when gcc use -O2
# edd 26 Nov 2002  switched back to g77
# edd 02 Jun 2003  switched back
# cts 04 Jun 2003  use -O1 on m68k
#ifeq ($(arch),m68k)
#fortrancompiler	= F2C=f2c
#compilerflags	= -O1
#endif

# edd 14 Nov 2003  turn blas off on arm
# edd 12 May 2010  no longer needed -- thx to Modestas Vainius
#ifeq ($(arch),arm)
#atlas		= --without-blas
#endif

## edd 09 Nov 2001  ia64 needs gcc-3.0, hppa gets it by default
#ifeq ($(arch),ia64)
#fortrancompiler = F77=g77-3.0
#compiler	= gcc-3.0
#cxxcompiler	= g++-3.0
#compilerflags	= -O2
#endif

## lamont@debian.org 06 Dec 2001  hppa needs -ffunction-sections
ifeq ($(arch),hppa)
optimflags	= -O2 -ffunction-sections
endif

## edd 20 Jun 2002	no optimisation or debugging on baby systems
## edd 02 Jun 2003	use this on arm only
## edd 12 May 2010	no longer use it on arm either -- thx Modestas
## edd 04 Aug 2010	on mips and mipsel, don't use -g
## edd 10 Jan 2016      turn all off again
##ifneq "$(findstring $(arch), m68k arm)" ""
#ifneq "$(findstring $(arch), arm)" ""
#ifneq "$(findstring $(arch), mips mipsel)" ""
#optimflags	= -g0
##optimflags	= -O0 -g0
#endif

## edd 04 Apr 2009	Alpha dies on deriv.c, trying will less optimisation
## edd 16 Apr 2009      commented-out as Kurt Roeckx applied a gcc patch
#ifeq ($(arch),alpha)
#optimflags	= -O2 -g0
#endif

## edd 09 Apr 2006	per patch from Andreas Jochens in #361604
ifeq ($(arch),powerpc64)
optimflags	+= -mminimal-toc
endif

## edd 26 Jul 2013	kFreeBSD wants -O2 per #714506
ifeq ($(buildos),kfreebsd)
optimflags	= -O2 -pipe
endif

## edd 30 Apr 2020      ppc64el aka powerpc64le has weird long double behavior breaking build
##                      so default to longdouble everywhere, but on powerpc64le
##                      also include powerpc64 and ppc64
longdouble      = --enable-long-double
ifneq "$(findstring $(arch), powerpc64le powerpc64 ppc64)" ""
longdouble      = --disable-long-double
endif

## edd 04 Apr 2006	generalize from old compilerflags to per-compiler
## edd 11 Oct 2011      -std=gnu goes to CC (thanks to Kurt Hornik)
cflags		= $(optimflags)
cxxflags	= $(optimflags)
## edd 31 Mar 2014      with thanks to Julian Gilbey in #726913
#fcflags		= $(optimflags)
fcflags 	= $(shell DEB_BUILD_MAINT_OPTIONS=optimize=-lto dpkg-buildflags --get FFLAGS)

## edd 17 Sep 2006	suggested by Brian Ripley in email dated 15 Sep 2006
#ldflags		= -Wl,-O1,-Bdirect,--hash-style=both
#ldflags		= -Wl,-O1
## edd 06 May 2007  try it
## edd 05 Feb 2008  still no go under gcc 4.3
#ldflags		= -Wl,-O1,-Bdirect,--hash-style=both
## edd 31 Mar 2014
ldflags		= $(shell dpkg-buildflags --get LDFLAGS)

## edd 16 Apr 2008	add -g to optim flags to allow for -dbg package
optimflags	+= -g

## 12 Jan 2015
## Support for #774031 uncomment the two assignment to pass a non-empty string for this to hold
#builttime       := $(shell dpkg-parsechangelog -l$(CURDIR)/debian/changelog | awk -F': ' '/Date/ {print $$2}')
#builttimestamp  := "$(builttime)"
buildtimestamp  := ""

#arch = kfreebsd-amd64
maketest:
	@echo "Hi $(arch)"
	@echo "$(findstring $(arch), i486 hppa arm)"
ifeq "$(findstring $(arch), kfreebsd-amd64 x86_64 hppa arm)" ""
	@echo "**** TRUE if the arch is NOT in the list as !find == '' ***"
endif
ifneq "$(findstring $(arch), kfreebsd-amd64 x86_64 i486 hppa arm)" ""
	@echo "**** TRUE if the arch is in list as find != '' is TRUE ***"
endif
	@echo Bye

get-orig-source: upstream
upstream:
        #links http://cran.us.r-project.org/src/base
	links http://cran.r-project.org/src/base/?M=D

upstreamdevel:
	links ftp://ftp.stat.math.ethz.ch/Software/R
        #links http://cran.us.r-project.org/src/base
        #rsync -vaC rsync.r-project.org::r-devel .

prerelease:
	links http://cran.r-project.org/src/base-prerelease

denmark:
	links http://www.biostat.ku.dk/~pd/R-release


## edd 24 Oct 2003  build is invoked by the buildd, so we would prefer to
##		    not imply build-indep; unfortunately R does not build
##		    properly without it, so we have to stick with it
## edd 15 Jan 2004  trying again on build only build: build-arch build-indep
##		    the main hook is to then have binary depend on both
